declare default element namespace 'http://пф.рф/ЭТК/СЗВ-ТД/2017-10-08';
declare namespace УТ = "http://пф.рф/УТ/2017-08-21";
declare namespace АФ = "http://пф.рф/АФ/2018-12-07";
declare variable $document as document-node() external;
declare variable $root := $document/ЭДПФР;
declare variable $snArray:=$root//УТ:СНИЛС;
declare function local:nodeIndex($nodes as node()*, $nodeToFind as node()) as xs:integer
{
for $seq in (1 to count($nodes))
				return $seq[$nodes[$seq] is $nodeToFind]
};
declare function local:nodePosition($node as node()?) as node()
{

				element {xs:QName("Результат")}
				{
				let $prefixes := ()
				let $prefixes := for $s in in-scope-prefixes($root) return insert-before($prefixes, 1, $s)
				let $ns := ()
				let $ns := for $p in $prefixes return insert-before($ns, 1, concat('Q{', namespace-uri-for-prefix($p, $root), '}'))
				return local:replacePathWithPrefixes(path($node), $ns, $prefixes)
				}
			
};
declare function local:replacePathWithPrefixes($path as xs:string?, $namespaces as xs:string*, $prefixes as xs:string*) as xs:string?
{

				if (count($namespaces) > 0)
				then local:replacePathWithPrefixes(
				replace($path, local:escape-for-regex($namespaces[1]), if (local:all-whitespace($prefixes[1])) then '' else concat($prefixes[1], ':')),
				$namespaces[position() > 1],
				$prefixes[position() > 1])
				else $path
			
};
declare function local:escape-for-regex($arg as xs:string?) as xs:string
{

				replace($arg, '(\.|\[|\]|\\|\||\-|\^|\$|\?|\*|\+|\{|\}|\(|\))','\\$1')
			
};
declare function local:result($path as xs:string, $expected as xs:anyAtomicType, $objectName as xs:string, $objectValue as xs:anyAtomicType) as node()
{

				if ($path = '0') then
				element {xs:QName("Результат")}
				{
				$path
				}
				else
				element {xs:QName("Результат")}
				{
				element {xs:QName("ПутьДоЭлемента")}
				{
				$path
				},
				element {xs:QName("ОжидаемоеЗначение")}
				{
				$expected
				},
				element {xs:QName("Объект")}
				{
				element {xs:QName("Наименование")}
				{
				$objectName
				},
				element {xs:QName("Значение")}
				{
				$objectValue
				}
				}
				}
			
};
declare function local:all-whitespace($arg as xs:string?) as xs:boolean
{
normalize-space($arg) = ''
};
declare function local:isEmpty($element) as xs:boolean
{
local:all-whitespace(string($element))
};
declare function local:substring-after-last($arg as xs:string?, $delim as xs:string) as xs:string
{
replace($arg, concat('^.*', local:escape-for-regex($delim)), '')
};
declare function local:getFIO($fio) as xs:string
{

				concat($fio/УТ:Фамилия, ' ', $fio/УТ:Имя, if (local:isEmpty($fio/УТ:Отчество)) then '' else concat(' ', $fio/УТ:Отчество))
			
};
declare function local:getResult($res as item()*) as item()*
{
if (exists($res)) then $res else local:result('0','','','')
};
<БлокПроверок ID="АФ.СХ.1" name="Дополнительные правила проверки электронных документов">
<БлокПроверок ID="1" name="Проверки файла на уникальность значений и соблюдение последовательностей">
<Проверка ID="2">
<Описание>Страховой номер застрахованного лица должен быть уникальным в пределах документа</Описание>
<РезультатЗапроса>
{
local:getResult(					 
						for $snils in $snArray 
						where count(index-of($snArray, $snils)) > 1 
						return local:result(local:nodePosition($snils),concat('СНИЛС = ', $snils, ' не уникальный'),'','')					
						)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
</БлокПроверок>
</БлокПроверок>

